/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUART USB֐𐧌䂵܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author		Atmel Corporation	: http://www.atmel.com \n
//!				xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2007, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

/*_____ ݸٰ ____________________________________________________________*/

#include "config.h"
#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"

#include "uart_usb_lib.h"

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

Uchar tx_counter;
Uchar rx_counter;

/*_____ 錾 _______________________________________________________________*/

/** 
  * @brief uart_usbײ؏
  */
void uart_usb_init(void)
{
	tx_counter = 0;
	rx_counter = 0;
}

/** 
  * @brief ̊֐USB޽ŕMꂽ𒲂ׂ܂B
  * 
  * @return bit (޲ĂǂݍݏȂTRUE)
  */
bit uart_usb_test_hit(void)
{
	if(!Is_device_enumerated())
		return FALSE;

	if (!rx_counter)
	{
		Usb_select_endpoint(RX_EP);
		if (Is_usb_receive_out())
		{
			rx_counter = Usb_byte_counter();
			if (!rx_counter)
			{
				Usb_ack_receive_out();
			}
		}
	}
	return (rx_counter!=0);
}

/** 
  * @brief ̊֐USB޽1޲Ăǂ݂܂B
  *
  * USB FIFO1޲Ă݂ȂA޲ĂԂ܂BUSB FIFOްS
  * ݂ȂꍇÅ֐USBް҂܂B
  * 
  * @return U8 M޲
  */
char uart_usb_getchar(void)
{
	register Uchar data_rx;

	Usb_select_endpoint(RX_EP);
	if (!rx_counter) while (!uart_usb_test_hit());
	data_rx=Usb_read_byte();
	rx_counter--;
	if (!rx_counter) Usb_ack_receive_out();
	return data_rx;
}

/**
  * @brief ̊֐USBsɏՕŒ1޲Ď󂯓ꏀ𒲂ׂ܂B
  * 
  * @return Boolean ̧ѳM̂߂̐V޲ĂƂłꍇTRUE
  */
bit uart_usb_tx_ready(void)
{
	if(!Is_device_enumerated())
		return FALSE;

	if (!Is_usb_write_enabled())
	{
		return FALSE;
	}
	return TRUE;
}

/**
  * @brief ̊֐͐VްUSBMɏՕ𖞂܂B̊ɏՕ͊
  * ꍇɑ܂Bt҂Oɂ̊ɏՕjɂ́Auart_usb_flush()
  * JnĂB
  * 
  * @param data_to_send
  * 
  * @return
  */
int uart_usb_putchar(int data_to_send)
{
	Usb_select_endpoint(TX_EP);
	while(!uart_usb_tx_ready());			// ߲ďҋ@
	Usb_write_byte(data_to_send);
	tx_counter++;
	if(!Is_usb_write_enabled())				// ߲ĖtȂΔj
	{
		uart_usb_flush();
	}
	return data_to_send;
}

/** 
  * @brief ̊֐USBMɏՕɊi[ꂽް𑗂܂B̊֐͊ɏ
  * ްꍇA܂B
  */
void uart_usb_flush (void)
{
	bit zlp=FALSE;
	if(!Is_device_enumerated())
		return;

	Usb_select_endpoint(TX_EP);
	if(!Is_usb_write_enabled())				// ߲ĖtȂA0߹(ZLP)Kv
	{
		zlp=TRUE;
	}
	Usb_send_in();
	if(zlp==TRUE)
	{
		while(Is_usb_write_enabled()==FALSE);	// ߲ďҋ@
		Usb_send_in();							// ZLPo
	}
	tx_counter = 0;
}
